"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
const __2 = require("..");
const symbols_1 = require("../symbols");
const routes = __1.createRoutes({
    index: __1.$route,
    about: __1.$route,
    users: {
        index: __1.$route,
        '[userId]': {
            index: __1.$route,
            posts: {
                '[postId]': {
                    index: __1.$route,
                },
            },
            settings: {
                index: __1.$route,
                lang: __1.$route,
            },
        },
    },
    users2: {
        test: __1.$route,
    },
});
describe('createRoutes', () => {
    test.each([
        [routes[symbols_1.$index], ''],
        [routes.index, '/'],
        [routes.about, '/about'],
        [routes.users[symbols_1.$index], '/users'],
        [routes.users.index, '/users'],
        [routes.users(null)[symbols_1.$index], '/users/[userId]'],
        [routes.users(null).index, '/users/[userId]'],
        [routes.users('123')[symbols_1.$index], '/users/123'],
        [routes.users('123').index, '/users/123'],
        [routes.users('123').posts('456').index, '/users/123/posts/456'],
        [routes.users(null).posts(null)[symbols_1.$index], '/users/[userId]/posts/[postId]'],
        [routes.users(null).posts(null).index, '/users/[userId]/posts/[postId]'],
        [routes.users('123').posts(null).index, '/users/123/posts/[postId]'],
        [routes.users('123').settings.index, '/users/123/settings'],
        [routes.users('123').settings.lang, '/users/123/settings/lang'],
    ])('%p', (actual, expected) => expect(actual).toBe(expected));
    // @ts-expect-error: non dynamic route
    void (() => routes.about());
    // @ts-expect-error: non dynamic route
    void (() => routes.users('123').settings());
});
describe('isSubpathOf', () => {
    test.each([
        ['/users', routes.users, true],
        ['/users/[userId]', routes.users, true],
        ['/users/[userId]/posts', routes.users, true],
        ['/users2/test', routes.users, false],
        ['/users', routes.users2, false],
        ['/about', routes.users, false],
    ])('%p', (pathname, routeOptions, expected) => expect(__2.isSubpathOf(pathname, routeOptions)).toBe(expected));
});
