"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cli = void 0;
const getopts_1 = __importDefault(require("getopts"));
const generate_1 = require("./commands/generate");
const help = `
Usage:

next-typed-pages generate <output-path>   Generate pages file
  --dir, -d         Path to pages directory (default: src/pages)
`.trim();
const cli = async () => {
    const { _: [command, ...args], dir, } = getopts_1.default(process.argv.slice(2), {
        alias: { dir: 'd' },
        default: { dir: 'src/pages' },
    });
    switch (command) {
        case 'generate':
            if (!args[0]) {
                console.error('Output path must be specified');
                process.exit(1);
            }
            void generate_1.generate({ output: args[0], dir });
            break;
        case '--help':
            console.log(help);
            break;
        default:
            console.log(help);
            process.exit(1);
    }
};
exports.cli = cli;
