"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = exports.buildGeneratedRoutesContent = void 0;
const fs_1 = require("fs");
const path_1 = require("path");
const nextPages_1 = require("../../nextPages");
const packageName = 'next-typed-pages';
const buildPagesObj = (dir) => {
    return Object.fromEntries(fs_1.readdirSync(dir, { withFileTypes: true })
        .map((dirent) => {
        if (dirent.isFile()) {
            const m = dirent.name.match(/^((?!_).+)\.tsx?$/);
            return (m === null || m === void 0 ? void 0 : m[1]) ? [m[1], '$route'] : undefined;
        }
        if (dirent.isDirectory()) {
            return [dirent.name, buildPagesObj(path_1.join(dir, dirent.name))];
        }
        return undefined;
    })
        .flatMap((entry) => (entry ? [entry] : [])));
};
const buildGeneratedRoutesContent = async ({ dir, output }) => {
    const pagesObj = JSON.stringify(buildPagesObj(dir), undefined, 2).replace(/"\$route"/g, '$route');
    const content = [
        `import { $route, ${nextPages_1.nextPages.name} } from '${packageName}'`,
        `export const { pages, usePagesRouter } = ${nextPages_1.nextPages.name}(${pagesObj})`,
    ]
        .filter((line) => line)
        .join('\n\n');
    const prettier = await Promise.resolve().then(() => __importStar(require('prettier'))).catch(() => undefined);
    if (!prettier) {
        return content;
    }
    const config = await prettier.default.resolveConfig(output);
    const formattedContent = prettier.default.format(content, {
        filepath: output,
        ...config,
    });
    return formattedContent;
};
exports.buildGeneratedRoutesContent = buildGeneratedRoutesContent;
const generate = async ({ dir, output }) => {
    const content = await exports.buildGeneratedRoutesContent({ dir, output });
    fs_1.writeFileSync(output, content);
    console.log(`🎉 Generated ${output}`);
};
exports.generate = generate;
